class EncoderFactorized(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  patcher3d : __torch__.projects.cosmos.tokenizer.v1.module.patching.Patcher3D
  conv_in : __torch__.torch.nn.modules.container.Sequential
  down : __torch__.torch.nn.modules.container.___torch_mangle_76.ModuleList
  mid : __torch__.torch.nn.modules.module.___torch_mangle_132.Module
  norm_out : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_134.CausalNormalize
  conv_out : __torch__.torch.nn.modules.container.___torch_mangle_139.Sequential
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.EncoderFactorized,
    input: Tensor) -> Tensor:
    conv_out = self.conv_out
    norm_out = self.norm_out
    mid = self.mid
    block_2 = mid.block_2
    mid0 = self.mid
    attn_1 = mid0.attn_1
    mid1 = self.mid
    block_1 = mid1.block_1
    down = self.down
    _1 = getattr(down, "1")
    block = _1.block
    _10 = getattr(block, "1")
    down0 = self.down
    _11 = getattr(down0, "1")
    block0 = _11.block
    _0 = getattr(block0, "0")
    down1 = self.down
    _00 = getattr(down1, "0")
    downsample = _00.downsample
    down2 = self.down
    _01 = getattr(down2, "0")
    block1 = _01.block
    _12 = getattr(block1, "1")
    down3 = self.down
    _02 = getattr(down3, "0")
    block2 = _02.block
    _03 = getattr(block2, "0")
    conv_in = self.conv_in
    patcher3d = self.patcher3d
    _4 = (conv_in).forward((patcher3d).forward(input, ), )
    _3 = (_12).forward((_03).forward(_4, ), )
    _2 = (_0).forward((downsample).forward(_3, ), )
    _5 = (block_1).forward((_10).forward(_2, ), )
    _6 = (block_2).forward((attn_1).forward(_5, ), )
    _7 = (norm_out).forward(_6, )
    x = torch.mul(_7, torch.sigmoid(_7))
    return (conv_out).forward(x, )
class CausalConv3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv3d : __torch__.torch.nn.modules.conv.Conv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalConv3d,
    argument_1: Tensor) -> Tensor:
    conv3d = self.conv3d
    _6 = torch.slice(argument_1, 0, 0, 9223372036854775807)
    _7 = torch.slice(_6, 1, 0, 9223372036854775807)
    x_prev = torch.repeat(torch.slice(_7, 2, 0, 1), [1, 1, 0, 1, 1])
    input = torch.cat([x_prev, argument_1], 2)
    input0 = torch.pad(input, [1, 1, 1, 1, 0, 0], "constant", 0.)
    return (conv3d).forward(input0, )
class CausalResnetBlockFactorized3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm1 : __torch__.projects.cosmos.tokenizer.v1.module.utils.CausalNormalize
  conv1 : __torch__.torch.nn.modules.container.___torch_mangle_6.Sequential
  norm2 : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_8.CausalNormalize
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  conv2 : __torch__.torch.nn.modules.container.___torch_mangle_13.Sequential
  nin_shortcut : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_15.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalResnetBlockFactorized3d,
    argument_1: Tensor) -> Tensor:
    nin_shortcut = self.nin_shortcut
    conv2 = self.conv2
    dropout = self.dropout
    norm2 = self.norm2
    conv1 = self.conv1
    norm1 = self.norm1
    _8 = (norm1).forward(argument_1, )
    x = torch.mul(_8, torch.sigmoid(_8))
    _9 = (norm2).forward((conv1).forward(x, ), )
    input = torch.mul(_9, torch.sigmoid(_9))
    _10 = (conv2).forward((dropout).forward(input, ), )
    _11 = (nin_shortcut).forward(argument_1, )
    return torch.add(_11, _10)
class CausalHybridDownsample3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_34.CausalConv3d
  conv2 : __torch__.torch.nn.modules.linear.___torch_mangle_35.Identity
  conv3 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_37.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalHybridDownsample3d,
    argument_1: Tensor) -> Tensor:
    conv3 = self.conv3
    conv1 = self.conv1
    x = torch.pad(argument_1, [0, 1, 0, 1, 0, 0], "constant", 0.)
    _12 = (conv1).forward(x, )
    x2 = torch.avg_pool3d(x, [1, 2, 2], [1, 2, 2], [0, 0, 0])
    x0 = torch.add(_12, x2)
    return (conv3).forward(x0, )
class CausalAttnBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_95.CausalNormalize
  q : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_97.CausalConv3d
  k : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_99.CausalConv3d
  v : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_101.CausalConv3d
  proj_out : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_103.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalAttnBlock,
    argument_1: Tensor) -> Tensor:
    proj_out = self.proj_out
    v = self.v
    k = self.k
    q = self.q
    norm = self.norm
    _13 = (norm).forward(argument_1, )
    _14 = (q).forward(_13, )
    _15 = (k).forward(_13, )
    _16 = (v).forward(_13, )
    element = ops.prim.NumToTensor(torch.size(_14, 0))
    element0 = ops.prim.NumToTensor(torch.size(_14, 1))
    element1 = ops.prim.NumToTensor(torch.size(_14, 2))
    element2 = ops.prim.NumToTensor(torch.size(_14, 3))
    element3 = ops.prim.NumToTensor(torch.size(_14, 4))
    result = torch.mul(element, CONSTANTS.c0)
    _17 = int(torch.mul_(result, element1))
    _18 = int(torch.mul(element0, CONSTANTS.c0))
    _19 = int(torch.mul(element2, CONSTANTS.c0))
    _20 = int(torch.mul(element3, CONSTANTS.c0))
    x = torch.permute(_14, [0, 2, 1, 3, 4])
    q0 = torch.reshape(x, [_17, _18, _19, _20])
    element4 = ops.prim.NumToTensor(torch.size(_15, 0))
    element5 = ops.prim.NumToTensor(torch.size(_15, 1))
    element6 = ops.prim.NumToTensor(torch.size(_15, 2))
    element7 = ops.prim.NumToTensor(torch.size(_15, 3))
    element8 = ops.prim.NumToTensor(torch.size(_15, 4))
    result0 = torch.mul(element4, CONSTANTS.c0)
    _21 = int(torch.mul_(result0, element6))
    _22 = int(torch.mul(element5, CONSTANTS.c0))
    _23 = int(torch.mul(element7, CONSTANTS.c0))
    _24 = int(torch.mul(element8, CONSTANTS.c0))
    x1 = torch.permute(_15, [0, 2, 1, 3, 4])
    k0 = torch.reshape(x1, [_21, _22, _23, _24])
    dim = ops.prim.NumToTensor(torch.size(_16, 0))
    _25 = int(dim)
    element9 = ops.prim.NumToTensor(torch.size(_16, 0))
    element10 = ops.prim.NumToTensor(torch.size(_16, 1))
    element11 = ops.prim.NumToTensor(torch.size(_16, 2))
    element12 = ops.prim.NumToTensor(torch.size(_16, 3))
    element13 = ops.prim.NumToTensor(torch.size(_16, 4))
    result1 = torch.mul(element9, CONSTANTS.c0)
    _26 = int(torch.mul_(result1, element11))
    _27 = int(torch.mul(element10, CONSTANTS.c0))
    _28 = int(torch.mul(element12, CONSTANTS.c0))
    _29 = int(torch.mul(element13, CONSTANTS.c0))
    x2 = torch.permute(_16, [0, 2, 1, 3, 4])
    v0 = torch.reshape(x2, [_26, _27, _28, _29])
    b = ops.prim.NumToTensor(torch.size(q0, 0))
    _30 = int(b)
    _31 = int(b)
    _32 = int(b)
    _33 = int(b)
    c = ops.prim.NumToTensor(torch.size(q0, 1))
    _34 = int(c)
    _35 = int(c)
    _36 = int(c)
    _37 = int(c)
    h = ops.prim.NumToTensor(torch.size(q0, 2))
    _38 = int(h)
    w = ops.prim.NumToTensor(torch.size(q0, 3))
    _39 = int(w)
    q1 = torch.reshape(q0, [_33, _37, int(torch.mul(h, w))])
    q2 = torch.permute(q1, [0, 2, 1])
    k1 = torch.reshape(k0, [_32, _36, int(torch.mul(h, w))])
    w_ = torch.bmm(q2, k1)
    input = torch.mul(w_, CONSTANTS.c3)
    w_0 = torch.softmax(input, 2)
    v1 = torch.reshape(v0, [_31, _35, int(torch.mul(h, w))])
    w_1 = torch.permute(w_0, [0, 2, 1])
    h_ = torch.bmm(v1, w_1)
    x3 = torch.reshape(h_, [_30, _34, _38, _39])
    _40 = ops.prim.NumToTensor(torch.size(x3, 0))
    element14 = ops.prim.NumToTensor(torch.size(x3, 1))
    _41 = int(element14)
    element15 = ops.prim.NumToTensor(torch.size(x3, 2))
    _42 = int(element15)
    element16 = ops.prim.NumToTensor(torch.size(x3, 3))
    _43 = int(element16)
    other = torch.mul(dim, CONSTANTS.c0)
    element17 = torch.floor_divide(_40, other)
    _44 = [_25, int(element17), _41, _42, _43]
    x4 = torch.reshape(x3, _44)
    x5 = torch.permute(x4, [0, 2, 1, 3, 4])
    x6 = torch.add(argument_1, (proj_out).forward(x5, ))
    return x6
class CausalTemporalAttnBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_105.CausalNormalize
  q : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_107.CausalConv3d
  k : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_109.CausalConv3d
  v : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_111.CausalConv3d
  proj_out : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_113.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalTemporalAttnBlock,
    argument_1: Tensor) -> Tensor:
    proj_out = self.proj_out
    v = self.v
    k = self.k
    q = self.q
    norm = self.norm
    _45 = (norm).forward(argument_1, )
    _46 = (q).forward(_45, )
    _47 = (k).forward(_45, )
    _48 = (v).forward(_45, )
    element = ops.prim.NumToTensor(torch.size(_46, 0))
    _49 = int(element)
    dim = ops.prim.NumToTensor(torch.size(_46, 3))
    _50 = int(dim)
    element18 = ops.prim.NumToTensor(torch.size(_46, 0))
    element19 = ops.prim.NumToTensor(torch.size(_46, 1))
    element20 = ops.prim.NumToTensor(torch.size(_46, 2))
    element21 = ops.prim.NumToTensor(torch.size(_46, 3))
    element22 = ops.prim.NumToTensor(torch.size(_46, 4))
    result = torch.mul(element18, CONSTANTS.c0)
    result2 = torch.mul_(result, element21)
    _51 = int(torch.mul_(result2, element22))
    _52 = int(torch.mul(element19, CONSTANTS.c0))
    _53 = int(torch.mul(element20, CONSTANTS.c0))
    x = torch.permute(_46, [0, 3, 4, 1, 2])
    q3 = torch.reshape(x, [_51, _52, _53])
    element23 = ops.prim.NumToTensor(torch.size(_47, 0))
    element24 = ops.prim.NumToTensor(torch.size(_47, 1))
    element25 = ops.prim.NumToTensor(torch.size(_47, 2))
    element26 = ops.prim.NumToTensor(torch.size(_47, 3))
    element27 = ops.prim.NumToTensor(torch.size(_47, 4))
    result3 = torch.mul(element23, CONSTANTS.c0)
    result4 = torch.mul_(result3, element26)
    _54 = int(torch.mul_(result4, element27))
    _55 = int(torch.mul(element24, CONSTANTS.c0))
    _56 = int(torch.mul(element25, CONSTANTS.c0))
    x7 = torch.permute(_47, [0, 3, 4, 1, 2])
    k2 = torch.reshape(x7, [_54, _55, _56])
    element28 = ops.prim.NumToTensor(torch.size(_48, 0))
    element29 = ops.prim.NumToTensor(torch.size(_48, 1))
    element30 = ops.prim.NumToTensor(torch.size(_48, 2))
    element31 = ops.prim.NumToTensor(torch.size(_48, 3))
    element32 = ops.prim.NumToTensor(torch.size(_48, 4))
    result5 = torch.mul(element28, CONSTANTS.c0)
    result6 = torch.mul_(result5, element31)
    _57 = int(torch.mul_(result6, element32))
    _58 = int(torch.mul(element29, CONSTANTS.c0))
    _59 = int(torch.mul(element30, CONSTANTS.c0))
    x8 = torch.permute(_48, [0, 3, 4, 1, 2])
    v2 = torch.reshape(x8, [_57, _58, _59])
    bhw = ops.prim.NumToTensor(torch.size(q3, 0))
    _60 = int(bhw)
    c = ops.prim.NumToTensor(torch.size(q3, 1))
    _61 = int(c)
    t = ops.prim.NumToTensor(torch.size(q3, 2))
    _62 = int(t)
    q4 = torch.permute(q3, [0, 2, 1])
    k3 = torch.permute(k2, [0, 2, 1])
    v3 = torch.permute(v2, [0, 2, 1])
    w_ = torch.bmm(q4, torch.permute(k3, [0, 2, 1]))
    w_2 = torch.mul(w_, CONSTANTS.c3)
    _63 = torch.ones_like(w_2, dtype=None, layout=None, device=None, pin_memory=False)
    mask = torch.tril(_63)
    input = torch.masked_fill(w_2, torch.eq(mask, 0), -inf)
    w_3 = torch.softmax(input, 2)
    h_ = torch.bmm(w_3, v3)
    x9 = torch.reshape(torch.permute(h_, [0, 2, 1]), [_60, _61, _62])
    _64 = ops.prim.NumToTensor(torch.size(x9, 0))
    element33 = ops.prim.NumToTensor(torch.size(x9, 1))
    _65 = int(element33)
    element34 = ops.prim.NumToTensor(torch.size(x9, 2))
    _66 = int(element34)
    known_product = torch.mul(dim, CONSTANTS.c0)
    other = torch.mul_(known_product, element)
    element35 = torch.floor_divide(_64, other)
    _67 = [_49, _50, int(element35), _65, _66]
    x10 = torch.reshape(x9, _67)
    x11 = torch.permute(x10, [0, 3, 4, 1, 2])
    x12 = torch.add(argument_1, (proj_out).forward(x11, ))
    return x12
class DecoderFactorized(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  unpatcher3d : __torch__.projects.cosmos.tokenizer.v1.module.patching.UnPatcher3D
  conv_in : __torch__.torch.nn.modules.container.___torch_mangle_144.Sequential
  mid : __torch__.torch.nn.modules.module.___torch_mangle_202.Module
  up : __torch__.torch.nn.modules.container.___torch_mangle_317.ModuleList
  norm_out : __torch__.projects.cosmos.tokenizer.v1.module.utils.___torch_mangle_319.CausalNormalize
  conv_out : __torch__.torch.nn.modules.container.___torch_mangle_324.Sequential
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.DecoderFactorized,
    argument_1: Tensor) -> Tensor:
    unpatcher3d = self.unpatcher3d
    conv_out = self.conv_out
    norm_out = self.norm_out
    up = self.up
    _0 = getattr(up, "0")
    block = _0.block
    _2 = getattr(block, "2")
    up0 = self.up
    _08 = getattr(up0, "0")
    block3 = _08.block
    _1 = getattr(block3, "1")
    up1 = self.up
    _09 = getattr(up1, "0")
    block4 = _09.block
    _010 = getattr(block4, "0")
    up2 = self.up
    _14 = getattr(up2, "1")
    upsample = _14.upsample
    up3 = self.up
    _15 = getattr(up3, "1")
    block5 = _15.block
    _20 = getattr(block5, "2")
    up4 = self.up
    _16 = getattr(up4, "1")
    block6 = _16.block
    _17 = getattr(block6, "1")
    up5 = self.up
    _18 = getattr(up5, "1")
    block7 = _18.block
    _011 = getattr(block7, "0")
    mid = self.mid
    block_2 = mid.block_2
    mid2 = self.mid
    attn_1 = mid2.attn_1
    mid3 = self.mid
    block_1 = mid3.block_1
    conv_in = self.conv_in
    _68 = (block_1).forward((conv_in).forward(argument_1, ), )
    _69 = (block_2).forward((attn_1).forward(_68, ), )
    _70 = (_17).forward((_011).forward(_69, ), )
    _71 = (upsample).forward((_20).forward(_70, ), )
    _72 = (_1).forward((_010).forward(_71, ), )
    _73 = (norm_out).forward((_2).forward(_72, ), )
    x = torch.mul(_73, torch.sigmoid(_73))
    _74 = (unpatcher3d).forward((conv_out).forward(x, ), )
    return _74
class CausalHybridUpsample3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.torch.nn.modules.linear.___torch_mangle_311.Identity
  conv2 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_313.CausalConv3d
  conv3 : __torch__.projects.cosmos.tokenizer.v1.module.layers3d.___torch_mangle_315.CausalConv3d
  def forward(self: __torch__.projects.cosmos.tokenizer.v1.module.layers3d.CausalHybridUpsample3d,
    argument_1: Tensor) -> Tensor:
    conv3 = self.conv3
    conv2 = self.conv2
    _75 = torch.repeat_interleave(argument_1, 2, 3)
    x = torch.repeat_interleave(_75, 2, 4)
    x13 = torch.add((conv2).forward(x, ), x)
    return (conv3).forward(x13, )
